/*----------------------------------------------------------------------------*
 *                                                                            *
 *  AGA-Morph-Vari.c V1.2                                                     *
 *                                                                            *
 *----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/

#include <libraries/diskfont.h>
#include <intuition/intuition.h>
#include <intuition/classes.h>
#include <intuition/pointerclass.h>
#include <datatypes/pictureclass.h>
#include <datatypes/pictureclassext.h>
#include <graphics/gfx.h>
#include <exec/memory.h>
#include <libraries/asl.h>
#include <clib/macros.h>

#include "AGA-Morph-Language.h"
#include "AGA-Morph-Struct.h"

/*----------------------------------------------------------------------------*/

struct Pic *DisplayPic(struct Pic *Picture,struct Window *DWin);
struct Pic *DisplaySpinPic(struct Pic *Picture1,struct Pic *Picture2,struct Window *DWin);
struct DPoint Points={0,0};
struct MPoint *Point1,*Point2;

struct DiskfontBase *DiskfontBase;
struct IntuitionBase *IntuitionBase;
struct GfxBase *GfxBase;
struct AslBase *AslBase;
struct DataTypesBase *DataTypesBase;
struct Screen *MorphScreen;
struct Window *EditWindow,*ViewWindow,*CommandWindow,*ErrorWindow,*ProWindow;
struct RastPort *EditRast,*ViewRast,*CommandRast,*VirtRast,temprp;
struct TextAttr NormalFont={"STG.font",8,FS_NORMAL,FPF_DISKFONT | FPF_DESIGNED};
struct TextFont *NFont;
struct BitMapHeader *BitMapHeader;
struct BitMap *BitMap;
struct Pic Picture1={0,0,0,0,0};
struct Pic Picture2={0,0,0,0,0};
struct Pic Picture3={0,0,0,0,0};
struct Pic *DisplayP,*EditP;
struct IntuiMessage *Mess;

LONG x,y,xstart,ystart,xmax,ymax,x1,y1,x2,y2,Error,i,j,k,Pos;
BYTE Ende,Direct;
BPTR file;

char *Name;

Object CrossPointer,ArrowPointer,LPicture;

ULONG ModeID,Signals,c,d,r,g,b;
ULONG Width,Height,Mode,Overscan,*PixelBuf;
LONG NumColours;

UWORD SmallEdit[4]={0,11,120,26};
UWORD SmallView[4]={320,11,120,26};
UWORD Colors[13]={1,0,1,2,1,3,1,0,2,1,2,1,0};

UBYTE Array[2048],*PlaneBuf[24],*Colours;
UBYTE RedrawEdit,RedrawView,MCol,Compr;
UBYTE Matrix[64]={ 1,26, 7,32, 2,27, 9,34,
                  38,13,45,20,40,15,46,21,
                  10,35, 4,29,12,37, 5,30,
                  48,23,41,16,49,24,43,18,
                   3,28, 9,34, 2,27, 8,33,
                  41,16,47,22,39,14,45,20,
                  13,38, 6,31,11,36, 5,30,
                  50,25,44,19,48,23,42,17};

/*----------------------------------------------------------------------------*/

/* End of Text */
