#ifndef METHOD_H
#define METHOD_H 1

//****************
//
// Name : Method.H
//
//****************


//******** Header Files

#ifndef MPMG_H
#include "MPMG.H"
#endif

//******** Macros

#define CALCTIME(x) ((x->gpi_IEvent->ie_TimeStamp.tv_secs*10)+(x->gpi_IEvent->ie_TimeStamp.tv_micro/100000))

//******** Protos for real Method functions, and class dispatcher.

ULONG MPMG_NEW( Class *cl, Object *o, struct opSet *ops );
ULONG MPMG_DISPOSE( Class *cl, Object *o, Msg msg );
ULONG MPMG_SET( Class *cl, Object *o, struct opSet *ops );
ULONG MPMG_GET( Class *cl, Object *o, struct opGet *opg );
ULONG MPMG_UPDATE( Class *cl, Object *o, struct opUpdate *opu );
ULONG MPMG_NOTIFY( Class *cl, Object *o, struct opUpdate *opu );
ULONG MPMG_RENDER( Class *cl, struct Gadget *o, struct gpRender *msg );
ULONG MPMG_GOACTIVE( Class *cl, Object *o, struct gpInput *gpi );
ULONG MPMG_HANDLEINPUT( Class *cl, Object *o, struct gpInput *gpi );
ULONG MPMG_GOINACTIVE( Class *cl, Object *o, struct gpGoInactive *gpgi );

//******** End of file
#endif

