//****************
//
// Name : Tree.h
//
//****************


//******** structure definitions

struct trunk {
  struct Node node;
  struct List list;
  BPTR DirLock;
  LONG Menu;
};

struct branch {
  struct Node node;
  char *Title;
  char *Data;
  ULONG type;
};

extern ULONG TreeHeight;

//******** Public procedures


extern void InitTree(void);
extern struct trunk *GetTop(void);
extern BOOL AddLevel(BPTR lock);
extern STRPTR AddBranch(STRPTR fn, STRPTR dr);
extern void DeleteLevel(void);
extern STRPTR FindNthBranch(long n);
extern ULONG MakeMenuFromTree(void);
extern struct trunk *ScanDir(char *st);
extern struct trunk *ScanVol(void);

//******** End of file

