#ifndef  CLIB_GTDRAG_PROTOS_H
#define  CLIB_GTDRAG_PROTOS_H

/*
**  $VER: gtdrag_protos.h 1.3 (1.11.96)
**  Includes Release 2.1
**
**  C prototypes. For use with 32 bit integers only.
**
**  (C) Copyright 1996 Axel Drfler
**      All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include <exec/types.h>
#endif
#ifndef  LIBRARIES_GTDRAG_H
#include <libraries/gtdrag.h>
#endif

/*--- functions in V1 or higher ---*/

/* Public entries */
struct IntuiMessage *GTD_GetIMsg(struct MsgPort *mp);
void GTD_ReplyIMsg(struct IntuiMessage *msg);
struct IntuiMessage *GTD_FilterIMsg(struct IntuiMessage *);
struct IntuiMessage *GTD_PostFilterIMsg(struct IntuiMessage *);
struct DragMsg *GTD_GetDragMsg(void);
void GTD_ReplyDragMsg(struct DragMsg *dm);
int GTD_AddAppA(STRPTR t,struct TagItem *tag);
int GTD_AddApp(STRPTR t,ULONG tag1,...);
void GTD_RemoveApp(void);
void GTD_AddWindowA(struct Window *win,struct TagItem *tag);
void GTD_AddWindow(struct Window *win,ULONG tag1,...);
void GTD_RemoveWindow(struct Window *);
void GTD_AddGadgetA(ULONG type,struct Gadget *gad,struct Window *win,struct TagItem *tag);
void GTD_AddGadget(ULONG type,struct Gadget *gad,struct Window *win,ULONG tag1,...);
void GTD_RemoveGadget(struct Gadget *);

#endif   /* CLIB_GTDRAG_PROTOS_H */
