//****************
//
// Name : MPMG.C
//
//****************


//******** Header Files

#include <clib/intuition_protos.h>
#include <pragmas/intuition_pragmas.h>
#include "MPMG.H"
#include "Dispatcher.h"

extern struct Library *IntuitionBase;

typedef ULONG (*HookFunction)(void);

//******** Public functions

Class *MPMG_CreateClass( void ) {
  Class *cl;
  extern ULONG HookEntry();     /* defined in amiga.lib */

  
  if (cl = MakeClass (NULL, GADGETCLASS, NULL, sizeof(MPMGData), 0) ) {
    cl->cl_Dispatcher.h_Entry = (HookFunction)MPMG_Dispatcher;
  }

  return (cl);
} // MPMG_CreateClass


BOOL MPMG_DisposeClass( Class *cl ) {
  return (FreeClass(cl)) ;
} // MPMG_DisposeClass

//******** End of file

